org.eclipse.jgit.lib

## Class ObjectInserter

- java.lang.Object
- - org.eclipse.jgit.lib.ObjectInserter

Direct Known Subclasses:
  DfsInserter, ObjectInserter.Filter, ObjectInserter.Formatter

    public abstract class ObjectInserter
    extends Object

Inserts objects into an existing `ObjectDatabase`.

An inserter is not thread-safe. Individual threads should each obtain their own unique inserter instance, or must arrange for locking at a higher level to ensure the inserter is in use by no more than one thread at a time.

Objects written by an inserter may not be immediately visible for reading after the insert method completes. Callers must invoke either `release()` or `flush()` prior to updating references or otherwise making the returned ObjectIds visible to other code.

### Nested Class Summary

Nested Classes
`static class` `ObjectInserter.Filter` Wraps a delegate ObjectInserter.
`static class` `ObjectInserter.Formatter` An inserter that can be used for formatting and id generation only.

### Constructor Summary

Constructors
`protected` `ObjectInserter()` Create a new inserter for a database.

### Method Summary

Methods
`protected byte[]` `buffer()` Obtain a temporary buffer for use by the ObjectInserter or its subclass.
`protected MessageDigest` `digest()`
`abstract void` `flush()` Make all inserted objects visible.
`ObjectId` `idFor(int type, byte[] data)` Compute the name of an object, without inserting it.
`ObjectId` `idFor(int type, byte[] data, int off, int len)` Compute the name of an object, without inserting it.
`ObjectId` `idFor(int objectType, long length, InputStream in)` Compute the name of an object, without inserting it.
`ObjectId` `idFor(TreeFormatter formatter)` Compute the ObjectId for the given tree without inserting it.
`ObjectId` `insert(CommitBuilder builder)` Insert a single commit into the store, returning its unique name.
`ObjectId` `insert(int type, byte[] data)` Insert a single object into the store, returning its unique name.
`ObjectId` `insert(int type, byte[] data, int off, int len)` Insert a single object into the store, returning its unique name.
`abstract ObjectId` `insert(int objectType, long length, InputStream in)` Insert a single object into the store, returning its unique name.
`ObjectId` `insert(TagBuilder builder)` Insert a single annotated tag into the store, returning its unique name.
`ObjectId` `insert(TreeFormatter formatter)` Insert a single tree into the store, returning its unique name.
`abstract PackParser` `newPackParser(InputStream in)` Initialize a parser to read from a pack formatted stream.
`abstract void` `release()` Release any resources used by this inserter.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ObjectInserter

    protected ObjectInserter()

Create a new inserter for a database.

### Method Detail

#### buffer

    protected byte[] buffer()

Obtain a temporary buffer for use by the ObjectInserter or its subclass.

This buffer is supplied by the ObjectInserter base class to itself and its subclasses for the purposes of pulling data from a supplied InputStream, passing it through a Deflater, or formatting the canonical format of a small object like a small tree or commit.

This buffer IS NOT for translation such as auto-CRLF or content filtering and must not be used for such purposes.

The returned buffer is small, around a few KiBs, and the size may change between versions of JGit. Callers using this buffer must always check the length of the returned array to ascertain how much space was provided.

There is a single buffer for each ObjectInserter, repeated calls to this method will (usually) always return the same buffer. If the caller needs more than one buffer, or needs a buffer of a larger size, it must manage that buffer on its own.

The buffer is usually on first demand for a buffer.

Returns:
  a temporary byte array for use by the caller.

#### digest

    protected MessageDigest digest()

Returns:
  digest to help compute an ObjectId

#### idFor

    public ObjectId idFor(int type,
                 byte[] data)

Compute the name of an object, without inserting it.

Parameters:
  `type` - type code of the object to store.
  `data` - complete content of the object.
Returns:
  the name of the object.

#### idFor

    public ObjectId idFor(int type,
                 byte[] data,
                 int off,
                 int len)

Compute the name of an object, without inserting it.

Parameters:
  `type` - type code of the object to store.
  `data` - complete content of the object.
  `off` - first position within `data`.
  `len` - number of bytes to copy from `data`.
Returns:
  the name of the object.

#### idFor

    public ObjectId idFor(int objectType,
                 long length,
                 InputStream in)
                   throws IOException

Compute the name of an object, without inserting it.

Parameters:
  `objectType` - type code of the object to store.
  `length` - number of bytes to scan from `in`.
  `in` - stream providing the object content. The caller is responsible for closing the stream.
Returns:
  the name of the object.
Throws:
  `IOException` - the source stream could not be read.

#### idFor

    public ObjectId idFor(TreeFormatter formatter)

Compute the ObjectId for the given tree without inserting it.

Parameters:
  `formatter` -
Returns:
  the computed ObjectId

#### insert

    public final ObjectId insert(TreeFormatter formatter)
                          throws IOException

Insert a single tree into the store, returning its unique name.

Parameters:
  `formatter` - the formatter containing the proposed tree's data.
Returns:
  the name of the tree object.
Throws:
  `IOException` - the object could not be stored.

#### insert

    public final ObjectId insert(CommitBuilder builder)
                          throws IOException

Insert a single commit into the store, returning its unique name.

Parameters:
  `builder` - the builder containing the proposed commit's data.
Returns:
  the name of the commit object.
Throws:
  `IOException` - the object could not be stored.

#### insert

    public final ObjectId insert(TagBuilder builder)
                          throws IOException

Insert a single annotated tag into the store, returning its unique name.

Parameters:
  `builder` - the builder containing the proposed tag's data.
Returns:
  the name of the tag object.
Throws:
  `IOException` - the object could not be stored.

#### insert

    public ObjectId insert(int type,
                  byte[] data)
                    throws IOException

Insert a single object into the store, returning its unique name.

Parameters:
  `type` - type code of the object to store.
  `data` - complete content of the object.
Returns:
  the name of the object.
Throws:
  `IOException` - the object could not be stored.

#### insert

    public ObjectId insert(int type,
                  byte[] data,
                  int off,
                  int len)
                    throws IOException

Insert a single object into the store, returning its unique name.

Parameters:
  `type` - type code of the object to store.
  `data` - complete content of the object.
  `off` - first position within `data`.
  `len` - number of bytes to copy from `data`.
Returns:
  the name of the object.
Throws:
  `IOException` - the object could not be stored.

#### insert

    public abstract ObjectId insert(int objectType,
                  long length,
                  InputStream in)
                             throws IOException

Insert a single object into the store, returning its unique name.

Parameters:
  `objectType` - type code of the object to store.
  `length` - number of bytes to copy from `in`.
  `in` - stream providing the object content. The caller is responsible for closing the stream.
Returns:
  the name of the object.
Throws:
  `IOException` - the object could not be stored, or the source stream could not be read.

#### newPackParser

    public abstract PackParser newPackParser(InputStream in)
                                      throws IOException

Initialize a parser to read from a pack formatted stream.

Parameters:
  `in` - the input stream. The stream is not closed by the parser, and must instead be closed by the caller once parsing is complete.
Returns:
  the pack parser.
Throws:
  `IOException` - the parser instance, which can be configured and then used to parse objects into the ObjectDatabase.

#### flush

    public abstract void flush()
                        throws IOException

Make all inserted objects visible.

The flush may take some period of time to make the objects available to other threads.

Throws:
  `IOException` - the flush could not be completed; objects inserted thus far are in an indeterminate state.

#### release

    public abstract void release()

Release any resources used by this inserter.

An inserter that has been released can be used again, but may need to be released after the subsequent usage.